!-----------------------------------------------------------------------
!**BEGIN PROLOGUE Precision
!**DATE WRITTEN   1998/10/01  (year/month/day)
!**AUTHORS
!
!  Marc Van Barel, Peter Kravanja
!
!    Department of Computer Science
!    Katholieke Universiteit Leuven
!    Celestijnenlaan 200 A
!    B-3001 Heverlee
!    BELGIUM
!    E-mail: Marc.VanBarel@cs.kuleuven.ac.be
!            Peter.Kravanja@na-net.ornl.gov
!
!**PURPOSE
!
! We define the integer "DP" that determines to which precision the floating
! point calculations are to be done.
!
!**END PROLOGUE Input
!-----------------------------------------------------------------------

MODULE Precision

     IMPLICIT NONE

!-----------------------------------------------------------------------
!**ACCESSIBILITY
!
     PRIVATE
     PUBLIC :: DP

!-----------------------------------------------------------------------
!  To which precision are the floating point calculations to be done?
!  The following corresponds to Fortran 77's "double precision".
!
     INTEGER, PARAMETER :: DP = SELECTED_REAL_KIND(15,70)

!-----------------------------------------------------------------------


END MODULE Precision
