     PROGRAM DCRatint_Main_SF

     USE Precision
     USE Timing
     USE Verbose_Module
     USE RatInt_Module

     IMPLICIT NONE

      INTEGER                                        :: m, tau, auxverbose
      INTEGER                                        :: hn
      INTEGER                                        :: i, nGreflimit
      REAL(KIND=DP)                                  :: alpha
      REAL(KIND=DP)                      :: time01, time02, time03, time04
      COMPLEX(KIND=DP), DIMENSION(:), ALLOCATABLE    :: dl, dr

!-----------------------------------------------------------------------

     time01 = GiveTime()
     time01 = GiveTime()

     OPEN(2,FILE='ratint.input',STATUS='OLD',ACTION='READ')
!!     OPEN(94,FILE='solveRIP.time',STATUS='OLD',POSITION='APPEND')
     OPEN(94,FILE='solveRIP.time',STATUS='REPLACE')

     READ(2,*) verbose
     READ(2,*) Ginitscaling
     READ(2,*) Giscaling
     READ(2,*) Gfinalscaling
     READ(2,*) Gfactor
     READ(2,*) Glimit
     READ(2,*) nGreflimit

     ALLOCATE(Greflimit(nGreflimit))

     READ(2,*) (Greflimit(i), i=1,nGreflimit)
     READ(2,*) Gshowresiduals
     READ(2,*) Gthreshold
     READ(2,*) Gnumzero
     READ(2,*) Gfinalfactor
     READ(2,*) Gnitref
     READ(2,*) Gfactoritref
     READ(2,*) Gnfitref
     READ(2,*) Gffactoritref
     READ(2,*) Gdowndating

     IF (verbose > 0) THEN
      print*,' '
      print*,'*** BEGIN SOLVE RATIONAL INTERPOLATION PROBLEM ***'
      print*,' '
      print*,'  Ginitscaling= ',Ginitscaling
      print*,'  Giscaling= ',Giscaling
      print*,'  Gfinalscaling= ',Gfinalscaling
      print*,'  Gfactor= ',Gfactor
      print*,'  Glimit = ',Glimit
      print*,'  nGreflimit = ',nGreflimit
      print*,'  Greflimit= ',Greflimit
      print*,'  Gshowresiduals= ',Gshowresiduals
      print*,'  Gthreshold= ',Gthreshold
      print*,'  Gnumzero= ',Gnumzero
      print*,'  Gfinalfactor= ',Gfinalfactor
      print*,'  Gnitref= ',Gnitref
      print*,'  Gfactoritref= ',Gfactoritref
      print*,'  Gnfitref= ',Gnfitref
      print*,'  Gffactoritref= ',Gffactoritref
      print*,'  Gdowndating= ',Gdowndating
      print*,' '
     END IF

     OPEN(1,FILE='inratint.dat',STATUS='OLD',ACTION='READ',FORM='UNFORMATTED')
     OPEN(3,FILE='outratint.dat',STATUS='REPLACE',ACTION='WRITE',&
          FORM='UNFORMATTED')
!! testresiduals
     OPEN(5,FILE='residuals.txt',STATUS='REPLACE')
!!     OPEN(5,FILE='residuals.txt',STATUS='OLD',POSITION='APPEND')
!! testresiduals
     OPEN(8,FILE='difficultpts.txt',STATUS='REPLACE')
!!     OPEN(8,FILE='difficultpts.txt',STATUS='OLD',POSITION='APPEND')
!! testpivot
     OPEN(9,FILE='pivot.txt',STATUS='REPLACE')
!! testpivot

     OPEN(15,FILE='dl.txt',STATUS='REPLACE')
     OPEN(16,FILE='dr.txt',STATUS='REPLACE')

     READ (1) auxverbose
     READ (1) m
     IF (verbose > 0) THEN
       print*,'  The number of interpolation conditions is ',m,'.'
       print*,' '
     END IF
     Gn = m
     ALLOCATE(Gz(m))
     ALLOCATE(resL(m))
     ALLOCATE(resR(m))
     ALLOCATE(dl(m))
     ALLOCATE(dr(m))
     READ (1) Gz
     READ (1) resL,resR
     READ (1) tau

120 FORMAT(I10)
121 FORMAT(2E27.18)

     time02 = GiveTime()

     CALL RatIntSf(resL,resR,m,tau,dl,dr,alpha,hn)

     time03 = GiveTime()

4000 FORMAT (I10)

     WRITE(3) auxverbose
     WRITE(3) m
     WRITE(3) dl
     WRITE(3) dr
     WRITE(3) alpha
     WRITE(3) hn

     WRITE(15,121) dl
     WRITE(16,121) dr

     time04 = GiveTime()

     IF (verbose > 0) THEN
       print*,'  Execution time of Subroutine RatIntSf = ',time03-time02
       print*,'  Execution time of Main Program = ',time04-time01
       print*,' '
       print*,'*** END SOLVE RATIONAL INTERPOLATION PROBLEM ***'
       print*,' '
     END IF

     WRITE(94,8010) time03-time02, time04-time01

     CLOSE(94)
     CLOSE(15)
     CLOSE(16)
     CLOSE(9)
     CLOSE(8)
     CLOSE(5)
     CLOSE(3)
     CLOSE(2)
     CLOSE(1)

8010 FORMAT(2ES9.2)

     END PROGRAM DCRatint_Main_SF
!
!-----------------------------------------------------------------------
!
