!-----------------------------------------------------------------------
!**BEGIN PROLOGUE Timing
!**DATE WRITTEN   1998/10/01  (year/month/day)
!**AUTHORS
!
!  Marc Van Barel, Peter Kravanja
!
!    Department of Computer Science
!    Katholieke Universiteit Leuven
!    Celestijnenlaan 200 A
!    B-3001 Heverlee
!    BELGIUM
!    E-mail: Marc.VanBarel@cs.kuleuven.ac.be
!            Peter.Kravanja@na-net.ornl.gov
!
!**PURPOSE
!
! This module contains the function GiveTime, which returns the elapsed
! time (etime) converted to precision "DP".
!
!**END PROLOGUE Timing
!-----------------------------------------------------------------------

MODULE Timing

     USE Precision

     IMPLICIT NONE

!-----------------------------------------------------------------------
!**ACCESSIBILITY
!
     PRIVATE
     PUBLIC :: GiveTime
!-----------------------------------------------------------------------

CONTAINS

     FUNCTION GiveTime()
     REAL(KIND=DP) :: GiveTime
     INTEGER(KIND=4) :: mclock

       GiveTime=Real(mclock(),DP)

     RETURN
     END FUNCTION GiveTime

!-----------------------------------------------------------------------


END MODULE Timing
