     PROGRAM Transform_T_RIP_Main
!-----------------------------------------------------------------------
!
! The Toeplitz-problem is transformed into a rational interpolation problem.
! The input comes from file "toeplitz.dat".
! The data for the rational interpolation problem is written on
! file "inratint.dat".
!
!-----------------------------------------------------------------------
     USE Precision
     USE Timing
     USE Verbose_Module
     USE Toeplitz_Module

     IMPLICIT NONE

     INTEGER   :: n, N2
     REAL(KIND=DP) :: time01, time02, time03, time04
     COMPLEX(KIND=DP), DIMENSION(:), ALLOCATABLE :: a, b


!-----------------------------------------------------------------------

       time01 = GiveTime()
       time01 = GiveTime()

       OPEN(1,ERR=9920,FILE='toeplitz.dat',STATUS='OLD', &
            FORM='UNFORMATTED',ACTION='READ')
!!       OPEN(94,ERR=9940,FILE='transformTRIP.time',STATUS='OLD',POSITION='APPEND')
       OPEN(94,ERR=9940,FILE='transformTRIP.time',STATUS='REPLACE')
  
! Read input.

       read(1) verbose
       read(1) n
       ALLOCATE(a(1:2*n-1)); ALLOCATE(b(n))
       read(1) N2
       read(1) a
       read(1) b


      IF (verbose > 0) THEN
        print*,' '
        print*,'*** BEGIN TRANSFORM TOEPLITZ DATA TO RIP-DATA ***'
        print*,' '
        print*,'  The input comes from file "toeplitz.dat".'
        print*,' '
        print*,'  The Toeplitz-problem is transformed into a rational',&
               ' interpolation problem.'
        print*,' '
        print*,'  The data for the rational interpolation problem',&
               ' is written on'
        print*,'  file "inratint.dat".'
        print*,' '
      END IF

      OPEN(11,FILE='inratint.dat',STATUS='REPLACE',ACTION='WRITE', &
           FORM='UNFORMATTED')

      time02 = GiveTime()
       CALL Transform_T_RIP(n,a,b)
      time03 = GiveTime()


      CLOSE(11)
    
  
      DEALLOCATE(a); DEALLOCATE(b)

      time04 = GiveTime()

      IF (verbose > 0) THEN
        print*,'  Execution time of subroutine Transform_T_RIP = ',time03-time02
        print*,'  Execution time of Main Program = ',time04-time01
        print*,' '
        print*,'*** END TRANSFORM TOEPLITZ DATA TO RIP-DATA ***'
        print*,' '
      END IF

      WRITE(94,8010) time03-time02, time04-time01

      CLOSE(94)
      CLOSE(1)

      GOTO 1000

8010 FORMAT (2ES9.2)
9920 STOP 'File "toeplitz.dat" does not exist.'
9940 STOP

1000 END PROGRAM Transform_T_RIP_Main
!
!-----------------------------------------------------------------------
!
